'  Copyright 2008 Raymond Allen
'  Settings for Demo Board Audio Output:  Right Pin# = 10, Left Pin# = 11   , VGA base=Pin16, TV base=Pin12

'  idea and data borrowed heavily from:  http://elm-chan.org/works/mxb/report.html



CON _clkmode = xtal1 + pll16x
    _xinfreq = 5_000_000       '80 MHz

    buffSize = 64

    A2 = 0          ';220Hz
    B2 = 1
    H2 = 2
    C2 = 3
    Cis2 = 4
    D2 = 5
    Dis2 = 6
    E2 = 7
    F2 = 8
    Fis2 = 9
    G2 = 10
    Gis2 = 11
    A3 = 12         ';440Hz
    B3 = 13
    H3 = 14
    C3 = 15
    Cis3 = 16
    D3 = 17
    Dis3 = 18
    E3 = 19
    F3 = 20
    Fis3 = 21
    G3 = 22
    Gis3 = 23
    A4 = 24         ';880Hz
    B4 = 25
    H4 = 26
    C4 = 27
    Cis4 = 28
    D4 = 29
    Dis4 = 30
    E4 = 31
    F4 = 32
    Fis4 = 33
    G4 = 34
    Gis4 = 35
    A5 = 36         ';1760Hz
    B5 = 37
    H5 = 38
    C5 = 39
    Cis5 = 40
    D5 = 41
    Dis5 = 42
    E5 = 43
    F5 = 44
    Fis5 = 45
    G5 = 46
    Gis5 = 47
    A6 = 48         ';3520Hz
    B6 = 49
    H6 = 50
    C6 = 51
    Cis6 = 52
    D6 = 53
    Dis6 = 54
    E6 = 55

    EoS = 255       ';End of score
    en = 128        ';End of line flag

VAR long parameter
    long buff1[buffSize]
    long buff2[buffSize]
    long stack1[100]
    word MonoData[buffSize]
    
OBJ


PUB Main|n,i,j
  'Play music

  Player(10,11)




  repeat
  'shut down here

PUB Player(PinR, PinL)|n,i,nextCnt,j,mt,c,tick,dt,last,note
  'Play the wav data using counter modules
  'although just mono, using both counters to play the same thing on both left and right pins

  'Set pins to output mode
  DIRA[PinR]~~                              'Set Right Pin to output
  DIRA[PinL]~~                              'Set Left Pin to output

  'Set up the counters
  CTRA:= %00110 << 26 + 0<<9 + PinR         'NCO/PWM Single-Ended APIN=Pin (BPIN=0 always 0)
  CTRB:= %00110 << 26 + 0<<9 + PinL         'NCO/PWM Single-Ended APIN=Pin (BPIN=0 always 0)   



  'Compress byte tables to longs (because Prop Tool's compiler won't cooperate :))
  'sine
  repeat i from 0 to 127 step 4
    j:=wt_loop[i]+wt_loop[i+1]<<8+wt_loop[i+2]<<16+wt_loop[i+3]<<24
    lwt_loop[i>>2]:=j
  'envelope
  repeat i from 0 to 255 step 4
    j:=envelope[i]+envelope[i+1]<<8+envelope[i+2]<<16+envelope[i+3]<<24
    lenvelope[i>>2]:=j  
  'lwt_attack
  repeat i from 0 to 895 step 4
    j:=wt_attack[i]+wt_attack[i+1]<<8+wt_attack[i+2]<<16+wt_attack[i+3]<<24
    lwt_attack[i>>2]:=j

  cognew(@asmmusic,@parameter)

  repeat
    'Play 1st melody
    waitcnt(cnt+clkfreq/2)
    i:=0
    c:=cnt
    tick:=clkfreq/180'400000
    mt:=0
    repeat
      'get time of next note
      j:=melody[i++]
      j+=melody[i++]<<8
      'wait until time
      dt:=(j-mt)*tick
      mt:=j
      c+=dt
      if dt>0
        waitcnt(c)
      'get note
      repeat
        j:=melody[i++]
        last:=0
        if j==Eos
          quit
        if j&en
          last:=1
          j-=en
        j:=tbl_pitch[j]
        parameter:=j
      until last>0
      if j==EoS'255 'start over
        quit

    'Play second melody
    waitcnt(cnt+clkfreq/2)  
    i:=0
    c:=cnt
    tick:=clkfreq/180'400000
    mt:=0    
    repeat
      'get time of next note
      j:=melody1[i++]
      j+=melody1[i++]<<8
      'wait until time
      dt:=(j-mt)*tick
      mt:=j
      c+=dt
      if dt>0
        waitcnt(c)
      'get note
      repeat
        j:=melody1[i++]
        last:=0
        if j==Eos
          quit
        if j&en
          last:=1
          j-=en
        j:=tbl_pitch[j]
        parameter:=j
      until last>0
      if j==EoS'255 'start over
        quit

    'Play third melody
    waitcnt(cnt+clkfreq/2)  
    i:=0
    c:=cnt
    tick:=clkfreq/180'400000
    mt:=0    
    repeat
      'get time of next note
      j:=melody2[i++]
      j+=melody2[i++]<<8
      'wait until time
      dt:=(j-mt)*tick
      mt:=j
      c+=dt
      if dt>0
        waitcnt(c)
      'get note
      repeat
        j:=melody2[i++]
        last:=0
        if j==Eos
          quit
        if j&en
          last:=1
          j-=en
        j:=tbl_pitch[j]
        parameter:=j
      until last>0
      if j==EoS'255 'start over
        quit    
    

 


DAT

';--------------------------------------------------------------------;
'; Pitch number to angular speed conversion table
';--------------------------------------------------------------------;
';Since sustain area of wave table, a cycle of fundamental frequency, is sampled
';in 128 points, the base frequency becomes 32000/128 = 250 Hz. The wave table
';lookup pointer, 16.8 fraction, is increased every sample by these 8.8 fractional
';angular speed values.

tbl_pitch word': ;  A     B     H     C    Cis    D    Dis    E     F    Fis    G    Gis 
              word 225, 239, 253, 268, 284, 301,  319,  338,  358,  379,  401,  425 '; 220Hz..
              word 451, 477, 506, 536, 568, 601,  637,  675,  715,  758,  803,  851 '; 440Hz..
              word 901, 955, 1011, 1072, 1135, 1203, 1274, 1350, 1430, 1515, 1606, 1701 '; 880Hz..
              word 1802, 1909, 2023, 2143, 2271, 2406, 2549, 2700, 2861, 3031, 3211, 3402 '; 1760Hz..
              word 3604, 3818, 4046, 4286, 4542, 4812, 5098, 5400                   '; 3520Hz

dat
        org
ASMMusic
setup
        'setup output pins
        MOV DMaskR,#1
        ROL DMaskR,OPinR
        OR DIRA, DMaskR
        MOV DMaskL,#1
        ROL DMaskL,OPinL
        OR DIRA, DMaskL
        'setup counters
        OR CountModeR,OPinR
        MOV CTRA,CountModeR
        OR CountModeL,OPinL
        MOV CTRB,CountModeL

        mov   Waitcount,cnt
        add   Waitcount,BigWait

        mov   nextchannel,#0

OuterLoop     'play attack then envelope on command
        mov   sample,#0  'reset current sample to zero

        mov   channel,#0
        
        'see if there's a new note to play
        rdlong  temp1,par                        
        cmp   temp1,zero wz,wc
  if_e  jmp   #ChannelLoop
        
        'got new note
NewPitch
        mov   pitches,temp1
        add   NewPitch,dlsb
        'mov  ienvelope,#0
        'mov  iattack,#0
NewCounts
        mov   pcounts,#0
        add   NewCounts,dlsb
        wrlong zero,par
        'check for channel wrap
        add   nextchannel,#1
        cmp   nextchannel,#4 wz,wc
  if_b  jmp   #ChannelLoop
        mov   nextChannel,#0
        movd  NewPitch,#pitches
        movd  NewCounts,#pcounts

ChannelLoop 'play attack or envelope depending on pcount
GetChannelPitch
        mov   pitch,pitches
        add   GetChannelPitch,#1 'set to next channel
GetChannelCount
        mov   pcount,pcounts
        add   GetChannelCount,#1    'set to next channel
        'play nothing if pitch==0
        cmp   pitch,#0 wz,wc
  if_e  jmp   #GetNextChannel

        'get current sample        
        call  #GetSample

        'save channel count
SaveChannelCount
        mov   pcounts,pcount
        add   SaveChannelCount,dlsb

GetNextChannel
        add   channel,#1
        cmp   channel,#4 wz,wc
  if_b  jmp   #ChannelLoop

PlaySample
        'reset pointers
        movs  GetChannelPitch,#pitches
        movs GetChannelCount,#pcounts
        movd SaveChannelCount,#pcounts
        'add in the bias and send to counter
        adds sample,bias        
        rol   sample,#16
        waitcnt WaitCount,dRate   
        MOV FRQA,sample
        MOV FRQB,sample
        
        jmp   #OuterLoop




GetSample
        'increment 16.8 pcount by pitch
        add   pcount,pitch
        'see if in attack or envelope phase
        mov   iattack,pcount
        shr   iattack,#8
        cmp   iattack,nattack wz,wc
  if_ae jmp   #PlayEnvelope

PlayAttack  'play attack sample
        mov   temp2,iattack
        shr   temp2,#2  'divide index by four to get long with byte data
        movs  getASample,#lwt_attack
        add   getASample,temp2
        nop    'for pipeline 
getASample
        mov   temp2,lwt_attack
        mov   temp1,iattack  'get relavent byte
        and   temp1,#3
        rol   temp1,#8
        ror   temp2,temp1
        rol   temp2,#24    'shift left,scale and bias        
        sar   temp2,#16+3     'scale for volume control

        adds  sample,temp2
        jmp   #GetSample_ret'PlaySample

PlayEnvelope
        mov   ienvelope,iattack
        sub   ienvelope,nattack
        mov   index,ienvelope 'save value for later getting sample
        'shr  ienvelope,#6  'make envelope last longer...
                'adjust evelope based on pitch
        mov temp1,pitch
        shr temp1,#12'10
        mov   temp2,#8
        sub   temp2,temp1
        shr   ienvelope,temp2
      

        'see if all done
        cmp   ienvelope,nenvelope wz, wc
  if_ae mov   pitch,#0
  if_ae jmp   #GetSample_ret'OuterLoop


        'get next envelope value
        mov   temp2,ienvelope
        shr   temp2,#2  'divide index by four to get long with byte data
        movs  getEnvelope,#lenvelope
        add   getEnvelope,temp2
        nop     'for pipeline
getEnvelope        
        mov   temp2,lenvelope
        mov   temp1,ienvelope 'get relavent byte
        and   temp1,#3
        rol   temp1,#8
        ror   temp2,temp1
        and   temp2,#255   
        mov   cenvelope,temp2


        'get next sample
        'mov  index,ienvelope
        and   index,#127 'wrap around sine table
        mov   temp2,index
        shr   temp2,#2  'divide index by four to get long with byte data
        movs  getSineSample,#lwt_loop
        add   getSineSample,temp2
        nop    'for pipeline 
getSineSample
        mov   temp2,lwt_loop
        mov   temp1,index  'get relavent byte
        and   temp1,#3
        rol   temp1,#8
        ror   temp2,temp1
        and   temp2,#255
        
        shl   temp2,#24

        mov   x,temp2
        abs   x,x
        shr   x,#24
        

        mov   y,cenvelope
        call  #mult
        shr   y,#8

        and y,#255

        shl   y,#8-3
        

        cmps   temp2,#0 wz,wc
  if_be neg   y,y
        adds  sample,y


GetSample_ret RET



' Multiply x[15..0] by y[15..0] (y[31..16] must be 0)
' on exit, product in y[31..0]
mult
        shl x,#16 'get multiplicand into x[31..16]
        mov t,#16 'ready for 16 multiplier bits
        shr y,#1 wc 'get initial multiplier bit into c
:loop
        if_c add y,x wc 'conditionally add multiplicand into product
        rcr y,#1 wc 'get next multiplier bit into c.
        ' while shift product
        djnz t,#:loop 'loop until done
mult_ret
        ret 'return with product in y[31..0]

        
                                 

'Working variables
thisCog long 0
x       long 0
y       long 0
z       long 0
t       long 0
dlsb    long    1 << 9
BigWait long 100000
BiggerWait long 10000000
twos    long $8000_8000

bias    long $0000_8000 '$3FFF_FFFF
        
'Loop parameters
nTable  long 0
WaitCount long 0
pData   long 0
LoopCount long 0
SizeBuff long buffsize
'Left    long 0
Right   long 0
Zero    long 0
pitches long  0[4]
pcounts long  0[4]
pitch   long 0'2271'1451
pcount  long 0       

'setup parameters
DMaskR  long 0 'right output mask
OPinR   long 10 'right channel output pin #                        '   <---------  Change Right pin# here !!!!!!!!!!!!!!    
DMaskL  long 0 'left output mask 
OPinL   long 11 'left channel output pin #                         '   <---------  Change Left pin# here !!!!!!!!!!!!!!    
CountModeR long %00011000_00000000_00000000_00000000
CountModeL long %00011000_00000000_00000000_00000000


'input parameters
pData1   long 0 'Address of first data table              
pData2   long 0 'Address of second data table
dRate    long 2500  'clocks between samples (==80MHz/32000)
nSamples long 128

lwt_loop long 0[32]  'compressed sine table of bytes
lenvelope long 0[64]  'compressed envelope table of bytes
lwt_attack long 0[224] 'compressed attack table of bytes
nattack long  896
nenvelope long 256

temp1   res 1
temp2   res 1
index   res 1
ienvelope res 1
cenvelope     res 1
iattack res 1
sample  res 1
channel res 1
nextchannel res 1

         fit  

';--------------------------------------------------------------------;
'; Envelope Table
';--------------------------------------------------------------------;
dat
envelope byte':   256 bytes
        byte 255,252,250,247,245,243,240,238,235,233,231,228,226,224,222,219
        byte 217,215,213,211,209,207,205,203,201,199,197,195,193,191,189,187
        byte 185,183,182,180,178,176,174,173,171,169,168,166,164,163,161,159
        byte 158,156,155,153,152,150,149,147,146,144,143,141,140,139,137,136
        byte 134,133,132,130,129,128,127,125,124,123,122,120,119,118,117,116
        byte 115,113,112,111,110,109,108,107,106,105,104,103,102,101,100,99
        byte 98,97,96,95,94,93,92,91,90,89,88,87,87,86,85,84
        byte 83,82,82,81,80,79,78,78,77,76,75,75,74,73,72,72
        byte 71,70,69,69,68,67,67,66,65,65,64,64,63,62,62,61
        byte 60,60,59,59,58,57,57,56,56,55,55,54,54,53,53,52
        byte 51,51,50,50,49,49,48,48,48,47,47,46,46,45,45,44
        byte 44,43,43,43,42,42,41,40,40,39,39,38,38,37,37,36
        byte 35,35,34,34,33,33,32,31,31,30,30,29,29,28,28,27
        byte 26,26,25,25,24,24,23,22,22,21,21,20,20,19,19,18
        byte 17,17,16,16,15,15,14,13,13,12,12,11,11,10,10,9
        byte 8,8,7,7,6,6,5,4,4,3,3,2,2,1,1,0

dat
';--------------------------------------------------------------------;
'; Wave Table
';--------------------------------------------------------------------;
'; 8bit, 32 ksps, 250 Hz fundamental frequency

'        .org    3072/2  ; Bottom stored

wt_attack byte': ; Attack area  896 bytes 224 longs
        byte 0, 0, 0, 0, 0, 0, -1, -2, -2, -3, -2, -2, -1, 0, 0, 0
        byte 0, 0, -1, -2, -3, -3, -4, -4, -3, -2, -1, 0, 0, 1, 0, 0
        byte 0, -1, -2, -3, -3, -2, 0, 0, 2, 4, 5, 5, 5, 3, 1, 0
        byte -2, -3, -4, -3, -2, 0, 1, 2, 3, 2, 0, -2, -6, -11, -15, -18
        byte -19, -19, -16, -11, -5, 1, 8, 15, 20, 23, 24, 23, 20, 17, 13, 10
        byte 7, 6, 6, 8, 10, 13, 16, 18, 20, 20, 20, 19, 18, 18, 18, 18
        byte 19, 21, 24, 26, 27, 28, 27, 25, 22, 17, 11, 5, 0, -5, -9, -12
        byte -13, -13, -11, -9, -5, -1, 1, 4, 6, 6, 4, 0, -5, -12, -21, -30
        byte -39, -48, -56, -62, -66, -69, -70, -71, -70, -70, -70, -71, -72, -75, -77, -79
        byte -80, -78, -75, -69, -61, -50, -38, -26, -13, -2, 7, 15, 21, 25, 28, 30
        byte 33, 36, 40, 44, 49, 55, 59, 61, 62, 60, 56, 49, 42, 34, 27, 22
        byte 20, 21, 25, 33, 42, 52, 63, 72, 80, 86, 89, 90, 89, 87, 84, 81
        byte 79, 77, 75, 73, 72, 69, 66, 61, 55, 48, 39, 31, 22, 14, 6, 0
        byte -5, -10, -14, -17, -20, -22, -24, -26, -28, -29, -30, -31, -32, -33, -34, -35
        byte -36, -37, -39, -41, -44, -48, -52, -57, -63, -70, -77, -85, -94, -102, -110, -116
        byte -121, -124, -124, -121, -116, -109, -99, -89, -78, -68, -60, -53, -48, -45, -43, -43
        byte -43, -42, -41, -40, -37, -33, -29, -25, -22, -19, -17, -16, -15, -14, -12, -9
        byte -4, 2, 11, 22, 34, 46, 57, 67, 75, 81, 84, 86, 87, 86, 86, 85
        byte 85, 85, 86, 86, 87, 86, 84, 82, 78, 73, 69, 64, 60, 58, 56, 57
        byte 59, 62, 66, 70, 75, 79, 83, 86, 89, 91, 92, 92, 92, 90, 86, 81
        byte 73, 63, 52, 38, 24, 9, -5, -19, -31, -42, -50, -57, -61, -64, -66, -67
        byte -68, -68, -68, -67, -66, -64, -61, -56, -52, -46, -41, -36, -32, -29, -28, -28
        byte -30, -34, -39, -44, -50, -56, -62, -68, -74, -79, -84, -90, -95, -100, -104, -107
        byte -108, -108, -107, -103, -98, -92, -84, -76, -67, -58, -49, -40, -32, -24, -16, -8
        byte -1, 5, 11, 16, 20, 22, 22, 21, 18, 14, 10, 5, 1, -1, -3, -3
        byte -2, 0, 1, 5, 9, 12, 16, 20, 24, 28, 34, 40, 47, 55, 64, 72
        byte 81, 89, 96, 101, 105, 108, 108, 108, 107, 105, 103, 101, 100, 98, 96, 93
        byte 90, 87, 83, 79, 75, 70, 66, 62, 59, 56, 55, 53, 52, 51, 50, 48
        byte 46, 44, 42, 39, 37, 34, 31, 28, 24, 20, 15, 10, 3, -3, -12, -21
        byte -30, -39, -48, -57, -65, -72, -79, -85, -90, -95, -99, -103, -106, -109, -110, -112
        byte -112, -112, -111, -110, -109, -107, -106, -105, -104, -104, -103, -102, -101, -99, -97, -94
        byte -90, -86, -82, -78, -75, -72, -69, -67, -65, -63, -61, -58, -54, -50, -44, -38
        byte -31, -23, -16, -10, -4, 1, 6, 10, 14, 18, 23, 27, 32, 38, 43, 49
        byte 54, 59, 63, 67, 70, 73, 75, 77, 79, 81, 83, 85, 88, 91, 93, 96
        byte 99, 101, 103, 105, 107, 109, 110, 111, 112, 112, 112, 111, 109, 107, 104, 100
        byte 96, 92, 88, 83, 79, 75, 70, 65, 60, 55, 49, 43, 36, 30, 24, 18
        byte 12, 7, 3, 0, -3, -6, -8, -11, -14, -17, -20, -24, -28, -32, -37, -42
        byte -46, -51, -55, -59, -63, -67, -71, -75, -79, -82, -85, -88, -91, -93, -95, -97
        byte -98, -100, -101, -102, -103, -104, -104, -104, -103, -101, -99, -96, -93, -89, -86, -83
        byte -80, -78, -76, -75, -74, -73, -72, -71, -70, -68, -65, -63, -59, -56, -52, -48
        byte -44, -40, -35, -30, -24, -18, -11, -4, 3, 11, 19, 27, 34, 41, 48, 53
        byte 58, 63, 67, 71, 75, 79, 82, 86, 89, 92, 94, 95, 96, 97, 98, 98
        byte 99, 100, 101, 103, 105, 108, 110, 112, 114, 115, 115, 114, 113, 110, 107, 103
        byte 99, 95, 91, 87, 83, 79, 74, 70, 65, 59, 53, 47, 41, 35, 29, 24
        byte 19, 14, 11, 7, 4, 1, -1, -5, -9, -14, -19, -25, -31, -37, -43, -50
        byte -56, -62, -68, -73, -78, -83, -88, -92, -97, -101, -105, -109, -112, -115, -117, -119
        byte -120, -121, -120, -119, -118, -116, -114, -112, -109, -106, -104, -101, -99, -96, -94, -91
        byte -88, -85, -81, -78, -74, -70, -66, -62, -57, -53, -49, -45, -41, -37, -32, -27
        byte -22, -16, -10, -4, 1, 8, 14, 20, 25, 31, 36, 41, 46, 50, 55, 60
        byte 64, 69, 73, 77, 81, 85, 88, 90, 93, 95, 97, 99, 101, 103, 106, 109
        byte 112, 115, 118, 121, 123, 125, 126, 126, 125, 125, 123, 121, 119, 117, 115, 112
        byte 110, 107, 103, 99, 94, 89, 83, 76, 69, 62, 54, 47, 39, 31, 24, 16
        byte 9, 2, -4, -11, -18, -25, -31, -38, -44, -51, -57, -62, -68, -73, -79, -84
        byte -88, -93, -97, -102, -106, -109, -113, -116, -119, -121, -123, -124, -125, -126, -127, -127
        byte -127, -127, -126, -125, -125, -123, -122, -120, -118, -116, -114, -111, -107, -104, -100, -95
        byte -91, -86, -80, -75, -69, -63, -58, -52, -46, -40, -34, -28, -22, -16, -10, -4
dat

wt_loop byte': ; Sustain area
        byte 0, 5, 11, 17, 23, 28, 34, 39, 45, 50, 55, 60, 65, 69, 74, 78
        byte 82, 85, 89, 92, 95, 98, 100, 102, 104, 106, 107, 109, 109, 110, 110, 111
        byte 110, 110, 109, 108, 107, 106, 104, 102, 100, 98, 95, 93, 90, 87, 83, 80
        byte 76, 72, 68, 64, 59, 55, 50, 46, 41, 36, 31, 26, 21, 15, 10, 5
        byte 0, -5, -10, -15, -21, -26, -31, -36, -41, -46, -50, -55, -59, -64, -68, -72
        byte -76, -80, -83, -87, -90, -93, -95, -98, -100, -102, -104, -106, -107, -108, -109, -110
        byte -110, -111, -110, -110, -109, -109, -107, -106, -104, -102, -100, -98, -95, -92, -89, -85
        byte -82, -78, -74, -69, -65, -60, -55, -50, -45, -39, -34, -28, -23, -17, -11, -5
'wt_end:

        
dat
melody  byte
        byte 120, 0, E5|en, 150, 0, Dis5|en, 180, 0, E5|en, 210, 0, Dis5|en, 240, 0, E5|en, 14
        byte 1, H5|en, 44, 1, D5|en, 74, 1, C5|en, 104, 1, A5, A3|en, 134, 1, E3|en, 164
        byte 1, A4|en, 194, 1, C4|en, 224, 1, E4|en, 254, 1, A5|en, 28, 2, H5, E2|en, 58
        byte 2, E3|en, 88, 2, Gis3|en, 118, 2, E4|en, 148, 2, Gis4|en, 178, 2, H5|en, 208, 2
        byte C5, A3|en, 238, 2, E3|en, 12, 3, A4|en, 42, 3, E4|en, 72, 3, E5|en, 102, 3
        byte Dis5|en, 132, 3, E5|en, 162, 3, Dis5|en, 192, 3, E5|en, 222, 3, H5|en, 252, 3, D5|en
        byte 26, 4, C5|en, 56, 4, A5, A3|en, 86, 4, E3|en, 116, 4, A4|en, 146, 4, C4|en
        byte 176, 4, E4|en, 206, 4, A5|en, 236, 4, H5, E2|en, 10, 5, E3|en, 40, 5, Gis3|en
        byte 70, 5, E4|en, 100, 5, C5|en, 130, 5, H5|en, 160, 5, A5, A3|en, 190, 5, E3|en
        byte 220, 5, A4|en, 24, 6, E5|en, 54, 6, Dis5|en, 84, 6, E5|en, 114, 6, Dis5|en, 144
        byte 6, E5|en, 174, 6, H5|en, 204, 6, D5|en, 234, 6, C5|en, 8, 7, A5, A3|en, 38
        byte 7, E3|en, 68, 7, A4|en, 98, 7, C4|en, 128, 7, E4|en, 158, 7, A5|en, 188, 7
        byte H5, E2|en, 218, 7, E3|en, 248, 7, Gis3|en, 22, 8, E4|en, 52, 8, Gis4|en, 82, 8
        byte H5|en, 112, 8, C5, A3|en, 142, 8, E3|en, 172, 8, A4|en, 202, 8, E4|en, 232, 8
        byte E5|en, 6, 9, Dis5|en, 36, 9, E5|en, 66, 9, Dis5|en, 96, 9, E5|en, 126, 9, H5|en
        byte 156, 9, D5|en, 186, 9, C5|en, 216, 9, A5, A3|en, 246, 9, E3|en, 20, 10, A4|en
        byte 50, 10, C4|en, 80, 10, E4|en, 110, 10, A5|en, 140, 10, H5, E2|en, 170, 10, E3|en
        byte 200, 10, Gis3|en, 230, 10, E4|en, 4, 11, C5|en, 34, 11, H5|en, 64, 11, A5, A3|en
        byte 94, 11, E3|en, 124, 11, A4|en, 154, 11, H5|en, 184, 11, C5|en, 214, 11, D5|en, 244
        byte 11, E5, C3|en, 18, 12, G3|en, 48, 12, C4|en, 78, 12, G4|en, 108, 12, F5|en, 138
        byte 12, E5|en, 168, 12, D5, G2|en, 198, 12, G3|en, 228, 12, A4|en, 2, 13, F4|en, 32
        byte 13, E5|en, 62, 13, D5|en, 92, 13, C5, A3|en, 122, 13, E3|en, 152, 13, A4|en, 182
        byte 13, E4|en, 212, 13, D5|en, 242, 13, C5|en, 16, 14, H5, E2|en, 46, 14, E3|en, 76
        byte 14, E4|en, 106, 14, E4|en, 136, 14, E5|en, 166, 14, E4|en, 196, 14, E5|en, 226, 14
        byte E5|en, 0, 15, E6|en, 30, 15, Dis5|en, 60, 15, E5|en, 90, 15, Dis5|en, 120, 15, E5|en
        byte 150, 15, Dis5|en, 180, 15, E5|en, 210, 15, Dis5|en, 240, 15, E5|en, 14, 16, Dis5|en, 44
        byte 16, E5|en, 74, 16, Dis5|en, 104, 16, E5|en, 134, 16, H5|en, 164, 16, D5|en, 194, 16
        byte C5|en, 224, 16, A5, A3|en, 254, 16, E3|en, 28, 17, A4|en, 58, 17, C4|en, 88, 17
        byte E4|en, 118, 17, A5|en, 148, 17, H5, E2|en, 178, 17, E3|en, 208, 17, Gis3|en, 238, 17
        byte E4|en, 12, 18, Gis4|en, 42, 18, H5|en, 72, 18, C5, A3|en, 102, 18, E3|en, 132, 18
        byte A4|en, 162, 18, E4|en, 192, 18, E5|en, 222, 18, Dis5|en, 252, 18, E5|en, 26, 19, Dis5|en
        byte 56, 19, E5|en, 86, 19, H5|en, 116, 19, D5|en, 146, 19, C5|en, 176, 19, A5, A3|en
        byte 206, 19, E3|en, 236, 19, A4|en, 10, 20, C4|en, 40, 20, E4|en, 70, 20, A5|en, 100
        byte 20, H5, E2|en, 130, 20, E3|en, 160, 20, Gis3|en, 190, 20, E4|en, 220, 20, C5|en, 250
        byte 20, H5|en, 24, 21, A5, A3|en, 54, 21, E3|en, 84, 21, A4|en, 114, 21, H5|en, 144
        byte 21, C5|en, 174, 21, D5|en, 204, 21, E5, C3|en, 234, 21, G3|en, 8, 22, C4|en, 38
        byte 22, G4|en, 68, 22, F5|en, 98, 22, E5|en, 128, 22, D5, G2|en, 158, 22, G3|en, 188
        byte 22, A4|en, 218, 22, F4|en, 248, 22, E5|en, 22, 23, D5|en, 52, 23, C5, A3|en, 82
        byte 23, E3|en, 112, 23, A4|en, 142, 23, E4|en, 172, 23, D5|en, 202, 23, C5|en, 232, 23
        byte H5, E2|en, 6, 24, E3|en, 36, 24, E4|en, 66, 24, E4|en, 96, 24, E5|en, 126, 24
        byte E4|en, 156, 24, E5|en, 186, 24, E5|en, 216, 24, E6|en, 246, 24, Dis5|en, 20, 25, E5|en
        byte 50, 25, Dis5|en, 80, 25, E5|en, 110, 25, Dis5|en, 140, 25, E5|en, 170, 25, Dis5|en, 200
        byte 25, E5|en, 230, 25, Dis5|en, 4, 26, E5|en, 34, 26, Dis5|en, 64, 26, E5|en, 94, 26
        byte H5|en, 124, 26, D5|en, 154, 26, C5|en, 184, 26, A5, A3|en, 214, 26, E3|en, 244, 26
        byte A4|en, 18, 27, C4|en, 48, 27, E4|en, 78, 27, A5|en, 108, 27, H5, E2|en, 138, 27
        byte E3|en, 168, 27, Gis3|en, 198, 27, E4|en, 228, 27, Gis4|en, 2, 28, H5|en, 32, 28, C5
        byte A3|en, 62, 28, E3|en, 92, 28, A4|en, 122, 28, E4|en, 152, 28, E5|en, 182, 28, Dis5|en
        byte 212, 28, E5|en, 242, 28, Dis5|en, 16, 29, E5|en, 46, 29, H5|en, 76, 29, D5|en, 106
        byte 29, C5|en, 136, 29, A5, A3|en, 166, 29, E3|en, 196, 29, A4|en, 226, 29, C4|en, 0
        byte 30, E4|en, 30, 30, A5|en, 60, 30, H5, E2|en, 90, 30, E3|en, 120, 30, Gis3|en, 150
        byte 30, E4|en, 180, 30, C5|en, 210, 30, H5|en, 240, 30, A5, A3|en, 14, 31, E3|en, 44
        byte 31, A4|en, 74, 31, C5, E4, C4, B4|en, 104, 31, C5, F4, C4, A4|en, 134, 31
        byte C5, G4, E4, B4, G3|en, 164, 31, C5, F3|en, 194, 31, A4|en, 224, 31, C4|en, 254
        byte 31, A4|en, 28, 32, F5, C4|en, 58, 32, A4|en, 73, 32, E5|en, 88, 32, E5, F3|en
        byte 118, 32, B4|en, 148, 32, D4|en, 178, 32, B4|en, 208, 32, B6, D4|en, 238, 32, B4|en
        byte 253, 32, A6|en, 12, 33, A6, F3|en, 42, 33, G5, E4|en, 72, 33, F5, B4, G3
        byte F3|en, 102, 33, E5, E4|en, 132, 33, D5, B4, G3, F3|en, 162, 33, C5, E4|en, 192
        byte 33, B5, F3|en, 222, 33, A4|en, 252, 33, A5, C4|en, 26, 34, A4|en, 56, 34, A5
        byte C4|en, 71, 34, G4|en, 86, 34, A5, A4|en, 101, 34, B5|en, 116, 34, C5, F3|en, 146
        byte 34, A4|en, 176, 34, C4|en, 206, 34, A4|en, 236, 34, D5, C4|en, 10, 35, Dis5, A4|en
        byte 40, 35, E5, E3|en, 70, 35, A4|en, 100, 35, C4|en, 130, 35, E5, A4|en, 160, 35
        byte F5, D4, D3|en, 190, 35, A5, F3|en, 220, 35, C5, G3|en, 250, 35, E4|en, 24, 36
        byte G3|en, 54, 36, E4|en, 84, 36, D5, G3|en, 114, 36, G4|en, 129, 36, H5|en, 144, 36
        byte D5, E4, C4|en, 159, 36, G5|en, 174, 36, G4|en, 189, 36, G5|en, 204, 36, A5|en, 219
        byte 36, G5|en, 234, 36, H5, G4, F4|en, 249, 36, G5|en, 8, 37, C5, G4, E4|en, 23
        byte 37, G5|en, 38, 37, D5, G4, F4, D4|en, 53, 37, G5|en, 68, 37, E5, G4, E4
        byte C4|en, 83, 37, G5|en, 98, 37, C6|en, 113, 37, H6|en, 128, 37, A6, A4, F3|en, 143
        byte 37, G5|en, 158, 37, F5|en, 173, 37, E5|en, 188, 37, D5, H4, G3|en, 203, 37, G5|en
        byte 218, 37, F5|en, 233, 37, D5|en, 248, 37, D5, E4, C4|en, 7, 38, G5|en, 22, 38
        byte G4|en, 37, 38, G5|en, 52, 38, A5|en, 67, 38, G5|en, 82, 38, H5, G4, F4|en, 97
        byte 38, G5|en, 112, 38, C5, G4, E4|en, 127, 38, G5|en, 142, 38, D5, G4, F4, D4|en
        byte 157, 38, G5|en, 172, 38, E5, G4, E4, C4|en, 187, 38, G5|en, 202, 38, C6|en, 217
        byte 38, H6|en, 232, 38, A6, A4, F3|en, 247, 38, G5|en, 6, 39, F5|en, 21, 39, E5|en
        byte 36, 39, D5, H4, G3|en, 51, 39, G5|en, 66, 39, F5|en, 81, 39, D5|en, 96, 39
        byte E5, A4, Gis3|en, 111, 39, F5|en, 126, 39, E5|en, 141, 39, Dis5|en, 156, 39, E5|en, 171
        byte 39, H5|en, 186, 39, E5|en, 201, 39, Dis5|en, 216, 39, E5|en, 231, 39, H5|en, 246, 39
        byte E5|en, 5, 40, Dis5|en, 20, 40, E5|en, 110, 40, H5|en, 140, 40, E5|en, 170, 40, Dis5|en
        byte 200, 40, E5|en, 48, 42, EoS|en

dat
melody1 byte

        byte 0, 0, B5|en, 2, 0, Dis3|en, 100, 0, B4|en, 150, 0, Gis4|en, 175, 0, G4|en, 200
        byte 0, Dis4|en, 144, 1, C4|en, 148, 1, Dis4, G3|en, 152, 1, C3|en, 88, 2, B3|en, 32
        byte 3, Gis3|en, 36, 3, Gis4|en, 38, 3, C4, F2|en, 132, 3, C3|en, 182, 3, G4|en, 207
        byte 3, F4|en, 232, 3, C4, F3|en, 126, 4, Dis4|en, 176, 4, D4|en, 178, 4, B4|en, 179
        byte 4, F3|en, 181, 4, B3|en, 120, 5, F3|en, 170, 5, D4|en, 220, 5, C4|en, 14, 6
        byte B4|en, 64, 6, B5|en, 66, 6, G2|en, 114, 6, D3|en, 164, 6, G3|en, 214, 6, D4|en
        byte 8, 7, D5|en, 108, 7, B5|en, 208, 7, B5|en, 211, 7, C3|en, 52, 8, G3|en, 149
        byte 8, C4|en, 152, 8, E4|en, 153, 8, G4|en, 155, 8, C5, B4|en, 96, 9, Gis4|en, 100
        byte 9, F3|en, 196, 9, C4|en, 246, 9, Dis4|en, 40, 10, Gis4|en, 140, 10, B5|en, 190, 10
        byte C5|en, 240, 10, C5|en, 242, 10, B3|en, 84, 11, F3|en, 109, 11, Dis4|en, 134, 11, Gis4|en
        byte 159, 11, C5|en, 180, 11, B3|en, 183, 11, B4|en, 184, 11, D4|en, 185, 11, F4|en, 186
        byte 11, B5|en, 128, 12, B5|en, 130, 12, Dis3|en, 228, 12, B4|en, 22, 13, Gis4|en, 47, 13
        byte G4|en, 72, 13, Dis4|en, 74, 13, B4|en, 16, 14, B4|en, 18, 14, Dis4, C3|en, 116, 14
        byte G3|en, 216, 14, B3|en, 60, 15, D4|en, 110, 15, Dis4|en, 160, 15, C4|en, 162, 15, Gis4|en
        byte 166, 15, F2|en, 4, 16, C3|en, 54, 16, G4|en, 79, 16, F4|en, 104, 16, C4|en, 106
        byte 16, F3|en, 204, 16, C4|en, 254, 16, Dis4|en, 48, 17, D4|en, 49, 17, F3|en, 50, 17
        byte B4, B3|en, 248, 17, F3|en, 42, 18, D4|en, 92, 18, C4|en, 142, 18, B4|en, 192, 18
        byte B5|en, 194, 18, G3|en, 242, 18, B4|en, 36, 19, D4|en, 38, 19, D3|en, 86, 19, G4|en
        byte 136, 19, B5|en, 138, 19, G3|en, 30, 20, D5|en, 80, 20, B5|en, 82, 20, C3|en, 180
        byte 20, G3|en, 24, 21, C4|en, 25, 21, E4|en, 26, 21, G4|en, 27, 21, B4|en, 29, 21
        byte C5|en, 224, 21, C4, F3|en, 226, 21, Gis4, Gis3|en, 228, 21, Dis4|en, 168, 22, F3|en, 218
        byte 22, Gis4|en, 12, 23, B5|en, 62, 23, C5|en, 112, 23, F4|en, 115, 23, Gis4, Dis5|en, 117
        byte 23, B3|en, 212, 23, F3|en, 56, 24, F4|en, 59, 24, B5|en, 62, 24, D5, B4|en, 0
        byte 25, Dis4|en, 3, 25, G4|en, 5, 25, B5|en, 7, 25, B4, Dis3|en, 200, 25, Dis3|en, 250
        byte 25, G4|en, 44, 26, Gis4|en, 94, 26, B5|en, 144, 26, C4|en, 145, 26, Dis4|en, 146, 26
        byte B4, C5|en, 88, 27, Gis3|en, 32, 28, B3, D4|en, 34, 28, F3, F4|en, 36, 28, B4|en
        byte 232, 28, B4|en, 26, 29, F4|en, 76, 29, G4|en, 126, 29, Gis4|en, 176, 29, D4|en, 179
        byte 29, G4|en, 181, 29, B5, G3|en, 120, 30, D3|en, 220, 30, G3|en, 64, 31, C3, G3|en
        byte 65, 31, Dis4, C4|en, 8, 32, Dis4|en, 11, 32, B3|en, 58, 32, Dis4|en, 108, 32, F4|en
        byte 158, 32, G4|en, 208, 32, C4|en, 210, 32, Gis4, F4|en, 212, 32, F2|en, 152, 33, C3|en
        byte 202, 33, F3|en, 252, 33, G4|en, 46, 34, F4|en, 96, 34, C4|en, 97, 34, Gis3|en, 98
        byte 34, B3|en, 90, 35, Gis3|en, 140, 35, C4|en, 190, 35, Dis4|en, 240, 35, B3|en, 241, 35
        byte D4, B4|en, 242, 35, F3|en, 184, 36, F3|en, 128, 37, B5, Dis3|en, 228, 37, B4|en, 22
        byte 38, D4|en, 47, 38, G4|en, 72, 38, B5|en, 172, 38, D5|en, 16, 39, E4|en, 20, 39
        byte G4|en, 24, 39, C5, C3|en, 116, 39, G3|en, 216, 39, C4|en, 220, 39, E4|en, 224, 39
        byte G4|en, 226, 39, C5|en, 160, 40, Gis4|en, 162, 40, F2|en, 4, 41, C3|en, 54, 41, C4|en
        byte 79, 41, Dis4|en, 104, 41, Gis4, F3|en, 204, 41, B5|en, 254, 41, C5|en, 48, 42, D4|en
        byte 52, 42, F4|en, 54, 42, B5, B3|en, 148, 42, F3|en, 248, 42, B4|en, 192, 43, D4|en
        byte 196, 43, F4|en, 198, 43, B5, G2|en, 36, 44, D3|en, 136, 44, G3|en, 186, 44, B5|en
        byte 236, 44, C5|en, 30, 45, D5|en, 80, 45, C3|en, 84, 45, G3, E4|en, 86, 45, B4
        byte G4|en, 88, 45, B5|en, 24, 46, C5|en, 224, 46, F2|en, 227, 46, C3, C4|en, 230, 46
        byte F3|en, 233, 46, Dis4, Gis4|en, 12, 48, G4|en, 62, 48, F4|en, 112, 48, B3, C4|en, 114
        byte 48, Gis3, F4|en, 156, 49, D4|en, 0, 50, Gis2, B4|en, 3, 50, Dis4, Gis3|en, 200, 50
        byte Dis3|en, 144, 51, Dis2|en, 150, 51, B3|en, 156, 51, Dis3|en, 162, 51, G3|en, 168, 51, B4|en
        byte 174, 51, Dis4|en, 176, 54, EoS|en
';710
        

dat
melody2 byte

        byte 0, 0, C3|en,1, 0, E4|en, 2, 0, A5|en, 50, 0, E3|en, 75, 0, H5|en, 100
        byte 0, G3|en, 150, 0, H4, E4|en, 200, 0, G3|en, 250, 0, H4|en, 44, 1, E4|en, 94
        byte 1, H4|en, 144, 1, C3|en, 145, 1, E4|en, 146, 1, A5|en, 194, 1, E3|en, 219, 1
        byte H5|en, 244, 1, G3|en, 38, 2, H4, E4|en, 88, 2, G3|en, 138, 2, H4|en, 188, 2
        byte E4|en, 238, 2, H4|en, 32, 3, H3|en, 33, 3, E4|en, 34, 3, A5|en, 82, 3, D3|en
        byte 107, 3, H5|en, 132, 3, Fis3|en, 182, 3, A4, D5|en, 232, 3, Fis3|en, 26, 4, A4|en
        byte 76, 4, D4|en, 126, 4, A4|en, 176, 4, H3|en, 177, 4, E4|en, 178, 4, A5|en, 226
        byte 4, D3|en, 251, 4, H5|en, 20, 5, Fis3|en, 70, 5, A4, D5|en, 120, 5, Fis3|en, 170
        byte 5, A4|en, 220, 5, D4|en, 14, 6, A4|en, 64, 6, C3|en, 65, 6, E4|en, 66, 6
        byte A5|en, 114, 6, E3|en, 139, 6, H5|en, 164, 6, G3|en, 214, 6, H4, E4|en, 8, 7
        byte G3|en, 58, 7, H4|en, 108, 7, E4|en, 158, 7, H4|en, 208, 7, C3|en, 209, 7, E4|en
        byte 210, 7, A5|en, 2, 8, E3|en, 27, 8, H5|en, 52, 8, G3|en, 102, 8, H4, E4|en
        byte 152, 8, G3|en, 202, 8, H4|en, 252, 8, E4|en, 46, 9, H4|en, 96, 9, H3|en, 97
        byte 9, E4|en, 98, 9, A5|en, 146, 9, D3|en, 171, 9, H5|en, 196, 9, Fis3|en, 246, 9
        byte A4, D5|en, 40, 10, Fis3|en, 90, 10, A4|en, 140, 10, D4|en, 190, 10, A4|en, 240, 10
        byte H3|en, 241, 10, E4|en, 242, 10, A5|en, 34, 11, D3|en, 59, 11, H5|en, 84, 11, Fis3|en
        byte 134, 11, A4, E4|en, 136, 11, E5|en, 184, 11, Fis3|en, 234, 11, D4, D5|en, 28, 12
        byte A4, H5|en, 53, 12, A5|en, 78, 12, E3|en, 128, 12, E3|en, 129, 12, A4|en, 130, 12
        byte G4|en, 178, 12, G3|en, 228, 12, H4|en, 22, 13, D4|en, 72, 13, H4|en, 122, 13, Fis4|en
        byte 172, 13, G3|en, 222, 13, H4, G4|en, 16, 14, Dis3|en, 18, 14, G4|en, 66, 14, G3|en
        byte 116, 14, H4|en, 166, 14, Dis4|en, 216, 14, H4, A5|en, 10, 15, G3|en, 35, 15, G4|en
        byte 60, 15, Dis4|en, 110, 15, H4, A5|en, 160, 15, D3|en, 162, 15, H5|en, 210, 15, Fis3|en
        byte 4, 16, A4|en, 54, 16, D4|en, 104, 16, A4, H5|en, 154, 16, Fis4|en, 179, 16, D5|en
        byte 204, 16, Fis3|en, 254, 16, A4, E5|en, 48, 17, Cis3|en, 50, 17, H5|en, 98, 17, E3|en
        byte 148, 17, G3|en, 198, 17, H4|en, 248, 17, G3|en, 42, 18, H4, A5|en, 92, 18, E4
        byte G4|en, 142, 18, H4, Fis4|en, 192, 18, C3|en, 194, 18, E4|en, 242, 18, E3|en, 36, 19
        byte G3|en, 86, 19, H4|en, 136, 19, G3, H5|en, 186, 19, H4|en, 236, 19, E4, A5|en, 30
        byte 20, H4|en, 80, 20, H3|en, 82, 20, Fis4|en, 130, 20, D3|en, 180, 20, Fis3|en, 230, 20
        byte A4|en, 24, 21, Fis3|en, 74, 21, A4|en, 124, 21, D4|en, 174, 21, A4|en, 224, 21, E3|en
        byte 226, 21, E4|en, 18, 22, D3|en, 68, 22, Fis3|en, 118, 22, A4|en, 120, 22, A5|en, 168
        byte 22, Fis3|en, 218, 22, A4|en, 12, 23, D4, H5|en, 62, 23, A4|en, 112, 23, E2|en, 116
        byte 23, D4|en, 119, 23, E5|en, 124, 23, H3|en, 128, 23, E3|en, 144, 26, EoS|en
';510
        